program Soutez;
{$APPTYPE CONSOLE}
{$RTTI EXPLICIT METHODS([]) PROPERTIES([]) FIELDS([])}
{$STRINGCHECKS OFF}
{$INLINE ON}
{$O+}
{$R-}
uses
  Sysutils,
  windows, Math;

const
  LOOP_COUNT = 3;

procedure IntToStrExFmt(i:Integer; var s:string);
const
  sChars = '0123456789';
  ciMax = 15;

var
  iPos: Integer;
  iStore, ix: Integer;
  cSep: Char;
  arWork:array[1..ciMax] of Char; // vyhneme se alokacim
begin
  cSep := ThousandSeparator;
  iStore := i; // uschovej znamenko
  iPos := ciMax;
  i := abs(i);
  repeat
    // 1 rad
    ix := i mod 10;
    i := i div 10;
    arWork[iPos] := sChars[ix + 1];
    dec(iPos);
    if i = 0 then
      break;

    // 2 rad
    ix := i mod 10;
    i := i div 10;
    arWork[iPos] := sChars[ix + 1];
    dec(iPos);
    if i = 0 then
      break;

    // 3 rad
    ix := i mod 10;
    i := i div 10;
    arWork[iPos] := sChars[ix + 1];
    dec(iPos);
    if i = 0 then
      break;
    // separator
    arWork[iPos] := cSep;
    dec(iPos);
  until i = 0;
  if (iStore < 0) then
    arWork[iPos] := '-'
  else
    inc(iPos);
  // alokuj navratovy retezec o spravne velikosti
  SetLength(s, ciMax - iPos + 1);
  // move data
  move(arWork[iPos], s[1], (ciMax - iPos + 1) {$IFDEF UNICODE} *2 {$ENDIF});
end;

procedure RunTest;
var
  i: Integer;
  iMax: Integer;
  s: string;
begin
  i := -MaxInt;
  iMax := MaxInt div 2;
  while i < iMax  do
  begin
    IntToStrExFmt(i, s);
    inc(i, 100);
  end;
end;

procedure Check(iValue: Integer);
var
  s:string;
begin
  IntToStrExFmt(iValue, s);
  writeln(Format('%s, %d', [s, Length(s)]));
end;

var
  tick, tickend, frequency: Int64;
  sDummy: string;

  sOut:string;
  Loops: integer;
  CurTime, TotalTime, MaxTime, MinTime: DWORD;
begin
  TotalTime := 0;
  MaxTime := 0;
  MinTime := $ffffffff;
  writeln('ThousandSeparator:', Ord(ThousandSeparator));
  for Loops := 1 to LOOP_COUNT do
  begin
    QueryPerformanceFrequency(frequency);

    QueryPerformanceCounter(tick);
    RunTest;


    QueryPerformanceCounter(tickend);
// konec souteze
    CurTime := Round(1000*(tickend - tick)/frequency);
    Inc(TotalTime, CurTime);
    if CurTime < MinTime then
      MinTime := CurTime;
    if CurTime > MaxTime then
      MaxTime := CurTime;
  end;
  writeln(format('Autor: Radek ervinka,  kompilator:%f', [CompilerVersion]));

  writeln(Format('Last time = [%d]', [CurTime]));
  writeln(Format('Min time = [%d], Average time = [%d], Max time = [%d]',
    [MinTime, TotalTime div LOOP_COUNT, MaxTime]));
  writeln('Kontrola:');
  check(-123456789);
  check(-MaxInt);
  check(MaxInt);
  check(123456);
  check(-1);
  check(0);
end.
